<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="业务对象ID" prop="objId">
        <el-input
          v-model="queryParams.objId"
          placeholder="请输入业务对象ID"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="模板ID" prop="tplId">
        <el-input
          v-model="queryParams.tplId"
          placeholder="请输入模板ID"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="指标ID" prop="metricsId">
        <el-input
          v-model="queryParams.metricsId"
          placeholder="请输入指标ID"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="指标名称" prop="metricsName">
        <el-input
          v-model="queryParams.metricsName"
          placeholder="请输入指标名称"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="指标编码" prop="metricsCode">
        <el-input
          v-model="queryParams.metricsCode"
          placeholder="请输入指标编码"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="创建人" prop="createBy">
        <el-input
          v-model="queryParams.createBy"
          placeholder="请输入创建人"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="创建时间" prop="createTime">
        <el-date-picker clearable
          v-model="queryParams.createTime"
          type="date"
          value-format="YYYY-MM-DD"
          placeholder="请选择创建时间">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="更新人" prop="updateBy">
        <el-input
          v-model="queryParams.updateBy"
          placeholder="请输入更新人"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="更新时间" prop="updateTime">
        <el-date-picker clearable
          v-model="queryParams.updateTime"
          type="date"
          value-format="YYYY-MM-DD"
          placeholder="请选择更新时间">
        </el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['obj:metrics:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['obj:metrics:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['obj:metrics:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['obj:metrics:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="metricsList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="ID" align="center" prop="objMetricsId" />
      <el-table-column label="业务对象ID" align="center" prop="objId" />
      <el-table-column label="模板ID" align="center" prop="tplId" />
      <el-table-column label="指标ID" align="center" prop="metricsId" />
      <el-table-column label="指标名称" align="center" prop="metricsName" />
      <el-table-column label="指标编码" align="center" prop="metricsCode" />
      <el-table-column label="告警规则" align="center" prop="alarmRule" />
      <el-table-column label="创建人" align="center" prop="createBy" />
      <el-table-column label="创建时间" align="center" prop="createTime" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.createTime, '{y}-{m}-{d} {h}:{mi}:{s}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="更新人" align="center" prop="updateBy" />
      <el-table-column label="更新时间" align="center" prop="updateTime" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.updateTime, '{y}-{m}-{d} {h}:{mi}:{s}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['obj:metrics:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['obj:metrics:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改业务对象指标对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="metricsRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="业务对象ID" prop="objId">
          <el-input v-model="form.objId" placeholder="请输入业务对象ID" />
        </el-form-item>
        <el-form-item label="模板ID" prop="tplId">
          <el-input v-model="form.tplId" placeholder="请输入模板ID" />
        </el-form-item>
        <el-form-item label="指标ID" prop="metricsId">
          <el-input v-model="form.metricsId" placeholder="请输入指标ID" />
        </el-form-item>
        <el-form-item label="指标名称" prop="metricsName">
          <el-input v-model="form.metricsName" placeholder="请输入指标名称" />
        </el-form-item>
        <el-form-item label="指标编码" prop="metricsCode">
          <el-input v-model="form.metricsCode" placeholder="请输入指标编码" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Metrics">
    import { listMetrics, getMetrics, delMetrics, addMetrics, updateMetrics } from "@/api/obj/metrics";

    const { proxy } = getCurrentInstance();

const metricsList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    objId: null,
    tplId: null,
    metricsId: null,
    metricsName: null,
    metricsCode: null,
    alarmRule: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    remark: null
  },
  rules: {
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询业务对象指标列表 */
function getList() {
  loading.value = true;
  listMetrics(queryParams.value).then(response => {
    metricsList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    objMetricsId: null,
    objId: null,
    tplId: null,
    metricsId: null,
    metricsName: null,
    metricsCode: null,
    alarmRule: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    remark: null
  };
  proxy.resetForm("metricsRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.objMetricsId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加业务对象指标";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _objMetricsId = row.objMetricsId || ids.value
  getMetrics(_objMetricsId).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改业务对象指标";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["metricsRef"].validate(valid => {
    if (valid) {
      if (form.value.objMetricsId != null) {
        updateMetrics(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addMetrics(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _objMetricsIds = row.objMetricsId || ids.value;
  proxy.$modal.confirm('是否确认删除业务对象指标编号为"' + _objMetricsIds + '"的数据项？').then(function() {
    return delMetrics(_objMetricsIds);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => {});
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('obj/metrics/export', {
    ...queryParams.value
  }, `metrics_${new Date().getTime()}.xlsx`)
}

getList();
</script>
